#include "pch.h"

#include "FTNStruc.hpp"
#include "Common.hpp"
#include "Misc.hpp"
#include "Temp.hpp"
#include "BSO.hpp"


CBSOManager::CBSOManager() {
    int i, j, k, l;
    
    // prepare BSO directories
    
    for (i = 0, j = -1, k = -1, l = -1; GlobalVars.BinkOutboundPath[i] != '\0'; i++) {
        if (GlobalVars.BinkOutboundPath[i] == '\\') {
            k = j;
            j = i;
        }
        if (GlobalVars.BinkOutboundPath[i] == '.')
            l = i;
    }
    k++;
    if (k > 0)
        memcpy( BaseDir, GlobalVars.BinkOutboundPath, k );
    BaseDir[k] = '\0';
    i = strlen( GlobalVars.BinkOutboundPath );
    if (l < k)
        l = i-1;
    memcpy( DefaultDomainDir, GlobalVars.BinkOutboundPath, l );
    DefaultDomainDir[l] = '\0';

    *Name   = '\0';
    NameLen = 0;

    NumberOfBaseDirNames = GetNumberOfEnclosedNames(BaseDir);
}


CBSOManager::~CBSOManager() {
}


void CBSOManager::SetAddress(SFTNAddress &Addr) {
    // check another domain
    if (*Addr.Domain != '\0' && GlobalVars.fCheckDomainInBSO && 
        stricmp( GlobalVars.MainAddr.Domain, Addr.Domain ) != 0)
    {
        sprintf( Name, "%s%s.%03hx\\", BaseDir, Addr.Domain, Addr.Zone );
    }
    else {
        // check zone
        if (GlobalVars.MainAddr.Zone != Addr.Zone) {
            sprintf( Name, "%s.%03hx\\", DefaultDomainDir, Addr.Zone );
        }
        else
            strcpy( Name, GlobalVars.BinkOutboundPath );
    }

    NameLen = strlen( Name );
    if (Addr.Point != 0) {
        sprintf( Name + NameLen, "%04hx%04hx.pnt\\", Addr.Net, Addr.Node );
        NameLen += 13;
    }

    MakeDirStructure( Name, NumberOfBaseDirNames );

    if (Addr.Point != 0)
        sprintf( Name + NameLen, "%08hx.", Addr.Point );
    else
        sprintf( Name + NameLen, "%04hx%04hx.", Addr.Net, Addr.Node );

    NameLen = strlen(Name);
}

int CBSOManager::SetBusyFlag() {
    static char  BusyFileName[MAX_PATH];
    FILE        *bsy;

    strcpy( BusyFileName, Name );
    strcpy( Name + NameLen, "tmp" );
    bsy = GetTempFile( Name, "wb" );
    if (bsy == NULL)
        return (0);
    fclose(bsy);
    strcpy( BusyFileName + NameLen, "bsy" );
    if (rename( Name, BusyFileName ) != 0) {
        remove( Name );
        return (0);
    }
    return (1);
    
}

int CBSOManager::ClearBusyFlag() {
    strcpy( Name + NameLen, "bsy" );
    return(remove(Name) == 0);
}

int CBSOManager::BusyFlagExist() {
    if (SetBusyFlag()) {
        ClearBusyFlag();
        return (0);
    }
    return (1);
}
