#include "pch.h"

#include "FTNStruc.hpp"
#include "CfgParse.hpp"
#include "Links.hpp"

CLinks::CLinks() {
    LinksList = LastLink = Selected = NULL;
}

CLinks::~CLinks() {
    while (LinksList != NULL) {
        LastLink = LinksList->Next;
        delete LinksList;
        LinksList = LastLink;
    }
}

int CLinks::Select(SFTNAddress &SelAddr) {
    Selected = LinksList;
    while (Selected != NULL) {
        if (Selected->Address.Zone  == SelAddr.Zone  &&
            Selected->Address.Net   == SelAddr.Net   &&
            Selected->Address.Node  == SelAddr.Node  &&
            Selected->Address.Point == SelAddr.Point &&
            stricmp( Selected->Address.Domain, SelAddr.Domain) == 0)
            break;
        Selected = Selected->Next;
    }
    return (Selected != NULL);
}

void CLinks::Add(SLink &NewLink) {
    if (LinksList == NULL) {
        LinksList = new SLink;
        LastLink  = LinksList;
    }
    else {
        LastLink->Next = new SLink;
        LastLink       = LastLink->Next;
    }
    memcpy( LastLink, &NewLink, sizeof(SLink) );
    LastLink->Next = NULL;
}

int CLinks::SelectFirst() {
    Selected = LinksList;
    return (Selected != NULL);
}

int CLinks::SelectNext() {
    if (Selected != NULL)
        Selected = Selected->Next;
    return (Selected != NULL);
}
